blob: 4070746a43902a2c16d387ebcf158ec12a5c7e51 [file] [log] [blame]
name: Dart CI
on:
# Run on PRs and pushes to the default branch.
push:
branches: [ master ]
pull_request:
branches: [ master ]
schedule:
- cron: "0 0 * * 0"
env:
PUB_ENVIRONMENT: bot.github
jobs:
# Check code formatting and static analysis on a single OS (linux).
analyze:
runs-on: ubuntu-latest
strategy:
fail-fast: false
matrix:
sdk: [2.16.0-124.0.dev] # TODO(#262)
steps:
- uses: actions/checkout@v2
- uses: dart-lang/setup-dart@v1.0
with:
sdk: ${{ matrix.sdk }}
- id: install
name: Install dependencies
run: dart pub get
- name: Check formatting
run: dart format --output=none --set-exit-if-changed .
if: always() && steps.install.outcome == 'success'
- name: Analyze code
run: dart analyze --fatal-infos
if: always() && steps.install.outcome == 'success'
test:
needs: analyze
# This job requires clang-10 which is the default on 20.04
runs-on: ubuntu-20.04
steps:
- uses: actions/checkout@v2
- uses: dart-lang/setup-dart@v1.0
with:
sdk: 2.16.0-124.0.dev # TODO(#262)
- name: Install dependencies
run: dart pub get
- name: Install libclang-10-dev
run: sudo apt-get install libclang-10-dev
- name: Build test dylib
run: cd test/native_test && dart build_test_dylib.dart && cd ../..
- name: Run VM tests
run: dart test --platform vm
- name: Collect coverage
run: ./tool/coverage.sh
- name: Upload coverage
uses: coverallsapp/github-action@v1.1.2
with:
github-token: ${{ secrets.GITHUB_TOKEN }}
path-to-lcov: lcov.info